/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: org.accordproject.creativework@0.2.0

// imports

// Warning: Beware of circular dependencies when modifying these imports
import {IDuration} from './org.accordproject.time@0.3.0';
import {IPerson} from './org.accordproject.person@0.2.0';
import {IOrganization} from './org.accordproject.organization@0.2.0';
import {IConcept} from './concerto@1.0.0';

// interfaces
export enum BookGenre {
   Fantasy = 'Fantasy',
   Romance = 'Romance',
}

export enum Medium {
   Audio = 'Audio',
   Print = 'Print',
   Video = 'Video',
}

export interface ICreativeWork extends IConcept {
   creators: IPerson[];
   dateCreated: Date;
   medium: Medium;
   title?: string;
}

export type CreativeWorkUnion = IAlbum | 
IBook | 
ISong;

export interface IAlbum extends ICreativeWork {
   songs: ISong[];
}

export interface IBook extends ICreativeWork {
   publisher: IOrganization;
   genre: BookGenre;
}

export enum MusicGenre {
   Rock = 'Rock',
   Rap = 'Rap',
   Country = 'Country',
   Pop = 'Pop',
   Jazz = 'Jazz',
   Grime = 'Grime',
   ThrashMetal = 'ThrashMetal',
}

export interface ISong extends ICreativeWork {
   duration: IDuration;
   genre: MusicGenre;
   performers: IPerson[];
}

